SystemOrganization addCategory: #'HighOctane-Boxes'!
SystemOrganization addCategory: #'HighOctane-ProduitsRemarquables'!
SystemOrganization addCategory: #'HighOctane-LightsOut'!
SystemOrganization addCategory: #'HighOctane-Pen'!
SystemOrganization addCategory: #'HighOctane-Sandbox'!
SystemOrganization addCategory: #'HighOctane-Tests'!
SystemOrganization addCategory: #'HighOctane-Turtle'!
SystemOrganization addCategory: #'HighOctane-Keymappings'!
SystemOrganization addCategory: #'HighOctane-Compatibility'!

!String methodsFor: '*highoctane' stamp: 'PhilippeBack 3/19/2012 22:09'!
repeat: anInteger 
    | writer |

   writer := WriteStream on: String new.
   anInteger timesRepeat: [writer nextPutAll: self].
   ^writer contents
! !

!TextDoIt methodsFor: '*highoctane' stamp: 'PhilippeBack 4/15/2012 22:28'!
actOnClickFor: target in: container at: clickPoint editor: editor
  UITheme current inform: 'Clicked'.
  self halt.! !

Morph subclass: #HOCanvasMorph
	instanceVariableNames: 'drawBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOCanvasMorph commentStamp: 'PhilippeBack 3/18/2012 17:40' prior: 0!
Allows to draw on a canvas without subclassing.
All drawing code goes to a Block.!

!HOCanvasMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/26/2012 22:50'!
astroide
	"Some mathematical fun"

	| m |
	m := HOCanvasMorph new openInWorld.	"to draw:"
	m
		drawBlock: [ :aCanvas | 
			| t xa xc xb yc ya yb longueur nombreDeDroites |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := (200).
			yc := (200).
			ya := yc.
			xb := xc.	"aCanvas line: (self topLeft) to: xc@yc color: Color green."
			0
				to: longueur - 1
				do:
					[ :i | 
					t := 2 * Float pi * i / nombreDeDroites.
					xa := xc + (longueur * t cos).
					yb := yc + (longueur * t sin).
					aCanvas line: xa @ ya to: xb @ yb color: Color green ]
		 ]! !

!HOCanvasMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 16:51'!
example
"Then use like"
|m|

    m := HOCanvasMorph new openInWorld.

"to draw:"

    m drawBlock: [:c |
        c line: 10@10 to: 100@100 color: Color red
    ]! !

!HOCanvasMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 18:20'!
napperons
	"Some mathematical fun"

	| m |
	m := HOCanvasMorph new openInWorld.	"to draw:"
	m
		drawBlock: [ :aCanvas | 
			| n r t xa xc xb yc ya yb longueur nombreDeDroites |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := 200.
			yc := 200.
			n := 15.
			r := 100.
			0 to: n - 2 do: [ :i | 
				t := 2 * Float pi * i / n.
				i + 1 to: n - 1 do: [ :j | 
					| tj |
					tj := 2 * Float pi * j / n.
					xa := xc + (r * t cos).
					ya := yc + (r * t sin).
					xb := xc + (r * tj cos).
					yb := yc + (r * tj sin).
					(aCanvas asBalloonCanvas) line: xa @ ya to: xb @ yb color: Color green ] ] ]! !

!HOCanvasMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 16:49'!
drawBlock: aBlock
    drawBlock := aBlock.
    self changed.

! !

!HOCanvasMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 18:34'!
drawOn: aCanvas
    super drawOn: aCanvas.
    
    drawBlock ifNotNil: [
        aCanvas
            translateBy: self bounds origin
            clippingTo: self bounds
            during: [:canvas | drawBlock value: canvas]]
! !

!HOCanvasMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 16:48'!
initialize
    super initialize.
    self color: Color white.
    self extent: 400@400.
! !

Morph subclass: #HOTestMorphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTestMorphic methodsFor: 'drawing' stamp: 'PhilippeBack 3/28/2012 12:42'!
drawOn: aCanvas
   aCanvas
      fillOval: self bounds
      color: Color red! !

!HOTestMorphic methodsFor: 'event handling' stamp: 'PhilippeBack 3/28/2012 12:41'!
handlesKeyboard: aKeyBoardEvent
   ^aKeyBoardEvent isKeystroke! !

!HOTestMorphic methodsFor: 'event handling' stamp: 'PhilippeBack 3/28/2012 12:42'!
keyStroke: anEvent
   Transcript 
      show: 'You pressed key ';
      show: anEvent keyCharacter;
      cr.! !

!HOTestMorphic methodsFor: 'stepping and presenter' stamp: 'PhilippeBack 3/28/2012 12:41'!
step
   self world bounds bottom > self bottom
      ifTrue:[self bottom: (self bottom + 3)]! !

!HOTestMorphic methodsFor: 'stepping and presenter' stamp: 'PhilippeBack 3/28/2012 12:44'!
stepTime
  ^50! !

TextMorph subclass: #DigitalClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Boxes'!

!DigitalClock methodsFor: 'as yet unclassified' stamp: 'AndrewBlack 1/11/2012 18:22'!
step
	self newContents: Time now asString! !

ImageMorph subclass: #HOPRHelpOverlay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRHelpOverlay commentStamp: 'PhilippeBack 6/15/2012 21:57' prior: 0!
HOPRHelpOverlay is an overlay picture showing over the UI so that the user can understand what is expected.

Collaborator: HOPRConfiguration

!

!HOPRHelpOverlay methodsFor: 'event handling' stamp: 'PhilippeBack 6/15/2012 21:34'!
handlesMouseDown: anEvent 
    ^true! !

!HOPRHelpOverlay methodsFor: 'initialize' stamp: 'PhilippeBack 6/15/2012 21:52'!
initialize
	super initialize.
	self color: Color transparent.
	self image: HOPRConfiguration helpOverlayForm.
	self extent: 1024 @ 768.
	self position: 0 @ 0! !

!HOPRHelpOverlay methodsFor: 'event handling' stamp: 'PhilippeBack 6/15/2012 21:54'!
mouseDown: anEvent 
    anEvent redButtonPressed "click" 
        ifTrue: [self delete]. 
  ! !

ImageMorph subclass: #HOPRPart
	instanceVariableNames: 'oldLook symbol s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRPart commentStamp: 'PhilippeBack 7/12/2012 17:44' prior: 0!
HOPRPart is a part in the parts bin (HOPRPartsArea)!

!HOPRPart class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:30'!
symbol: aSymbol
   ^self basicNew initialize setSymbol: aSymbol.
   
! !

!HOPRPart class methodsFor: 'accessing' stamp: 'PhilippeBack 7/15/2012 01:31'!
symbol: aSymbol as: aModifier
	^self basicNew initialize setSymbol: aSymbol as: aModifier.! !

!HOPRPart methodsFor: 'dropping/grabbing' stamp: 'PhilippeBack 6/13/2012 23:20'!
aboutToBeGrabbedBy: aHand	
	super aboutToBeGrabbedBy: aHand.	
	^self
! !

!HOPRPart methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 10:54'!
contents
  ^symbol

! !

!HOPRPart methodsFor: 'event handling' stamp: 'PhilippeBack 6/12/2012 23:58'!
handlesMouseDown: anEvent 
    ^true! !

!HOPRPart methodsFor: 'event handling' stamp: 'PhilippeBack 6/13/2012 00:28'!
handlesMouseOver: anEvent 
    ^true! !

!HOPRPart methodsFor: 'initialize' stamp: 'PhilippeBack 6/13/2012 23:23'!
initialize
  super initialize.
  self color: Color gray;
			width: 40;
			height: 40.
  self borderWidth: 2.
  self image: HOPRConfiguration normalTileForm.
  self dragEnabled: true.! !

!HOPRPart methodsFor: 'dropping/grabbing' stamp: 'PhilippeBack 6/13/2012 00:36'!
justDroppedInto: aMorph event: anEvent
    
    (aMorph isKindOf: HOPRTrashcan) ifTrue: [
	  self delete.
    ] ifFalse: [
      self color: Color green.
      self changed.
    ].


! !

!HOPRPart methodsFor: 'event handling' stamp: 'PhilippeBack 6/13/2012 23:21'!
mouseDown: evt 
    | pickedupMorph |
evt redButtonPressed "click" 
        ifTrue: [
	     (self owner isKindOf: HOPRAnswerArea) ifFalse: [
		     pickedupMorph := self duplicate.
		     pickedupMorph color: Color red.
		     pickedupMorph image: HOPRConfiguration highlightTileForm.
		     evt hand grabMorph: pickedupMorph.
	     ] ifTrue: [
	         evt hand grabMorph: self.
	     ]     
	   ]. 
  
 ! !

!HOPRPart methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/12/2012 23:28'!
mouseDown_Disabled: anEvent 
    anEvent redButtonPressed "click" 
        ifTrue: [self color: Color red]. 
    anEvent yellowButtonPressed "action-click" 
        ifTrue: [self color: Color yellow]. 
    anEvent blueButtonPressed "action-click" 
        ifTrue: [self color: Color blue]. 
    self changed! !

!HOPRPart methodsFor: 'event handling' stamp: 'PhilippeBack 6/13/2012 23:21'!
mouseEnter: anEvent 
    super mouseEnter: anEvent.
    "oldColor := self color."
    self color: Color orange.
    self changed.! !

!HOPRPart methodsFor: 'event handling' stamp: 'PhilippeBack 6/13/2012 23:21'!
mouseLeave: anEvent 
   super mouseLeave: anEvent.
 "  self color: oldColor."
   self changed.! !

!HOPRPart methodsFor: 'accessing' stamp: 'PhilippeBack 7/15/2012 01:23'!
setSymbol: aSymbol
  ^self setSymbol: aSymbol as: #normal.! !

!HOPRPart methodsFor: 'accessing' stamp: 'PhilippeBack 7/15/2012 01:33'!
setSymbol: aSymbol as: aModifier
	| top left |
	symbol := aSymbol.
	s := StringMorph new contents: symbol.
	(aModifier == #exponent)
		ifTrue: [ 
			s font: (HOPRConfiguration font: 9).
			top := self top + ((self height - s height) // 2).
			left := self left + ((self width - s width) // 2) ]
		ifFalse: [ 
			s font: (HOPRConfiguration font: 24).
			top := self top + ((self height - s height) // 4).
			left := (self left + 3) * ((self width - s width) // 4) ].
	s color: HOPRConfiguration partTextColor.
	self addMorph: s.
	self flag: #FIXME.	"Center not really right, we need to use extent as well"
	s top: top.
	s left: left.
	^ self! !

!HOPRPart methodsFor: 'dropping/grabbing' stamp: 'PhilippeBack 6/13/2012 00:15'!
wantsToBeDroppedInto: aMorph
   (aMorph isKindOf: HOPRAnswerArea) ifTrue: [
	   ^true
   ].

   (aMorph isKindOf: HOPRTrashcan) ifTrue: [
	   ^true
   ].

  ^false.! !

ImageMorph subclass: #TurtleMorph
	instanceVariableNames: 'tilt size pen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Turtle'!

!TurtleMorph commentStamp: 'RJH 4/16/2008 03:24' prior: 0!
With TurtleMorph you can add methods to the class TurtleMorph and so simply programme new turtle actions. The normal kind of behaviour that occurs with scripting now happens with methods. This means that initial teaching of Smalltalk can be done using a typical turtle of the kind met in LOGO programming.
[Morphic is usually driven by scripts, but when you try to programme methods you have to take account of the fiddles that the programmers did to keep morphs efficient. Morphs divide into two parts, costume and player. For efficiency morphs only get given the player only when needed- so for example with the forward: message, this is implemented in the player class and not in the morph class, so the morph has to create a player in order to deal with the forward: message. This happens automatically when using the etoys system, but not if you write scripts in methods. TurtleMorph traps any messages that should go to the player and makes sure the necessary player exists before passing the message on. Without this feature, you would have to know where you were directing the message and use 'assuredPlayer' to make sure the player exists. TurtleMorph by-passes this, so you can write forward: and send it straight to the TurtleMorph WITHOUT having to know that actually the implementation passes it to a player that may or may not exist!!]
There is more work to be done on this - including making the turtle look better and be able to shuffle along visibly.!

!TurtleMorph methodsFor: 'system' stamp: 'PhilippeBack 3/28/2012 16:30'!
doesNotUnderstand: aMessage
  "TODO: add behaviors to the TurtleMorph"
	(self respondsTo: aMessage selector) ifTrue: [
		^self perform: aMessage selector withArguments: aMessage arguments].
	^super doesNotUnderstand: aMessage! !

!TurtleMorph methodsFor: 'example' stamp: 'PhilippeBack 3/28/2012 17:17'!
draw
"TODO: use this to manage the turtle as an example"
| myPen |
myPen := self pen. "Create a new Pen for drawing" 
myPen up. "Don't draw while setting it up"
"Set up the Pen with the Boxes' characteristics" 
myPen goto: position.
myPen turn: tilt.
myPen color: (Color black).
"Now put the Pen down and draw the box." myPen down.
4 timesRepeat: [myPen go: size; turn: 90].! !

!TurtleMorph methodsFor: 'example' stamp: 'PhilippeBack 3/28/2012 17:25'!
forward2: aSize
	"TODO: use this to manage the turtle as an example"

	| myPen |
	myPen := self pen.	"Create a new Pen for drawing"
	myPen up.	"Don't draw while setting it up"	"Set up the Pen with the Boxes' characteristics"
	myPen goto: self position.
	myPen turn: self tilt.
	myPen color: Color black.	"Now put the Pen down and draw the box."
	myPen down.
	myPen go: aSize! !

!TurtleMorph methodsFor: 'turtle' stamp: 'PhilippeBack 3/28/2012 17:29'!
forward: aDistance 
	self pen go: aDistance.! !

!TurtleMorph methodsFor: 'system' stamp: 'RJH 4/15/2008 01:06'!
initialize

	super initialize.
	self image: self turtleForm! !

!TurtleMorph methodsFor: 'turtle' stamp: 'RJH 4/15/2008 02:57'!
north
	self heading: 0! !

!TurtleMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 17:34'!
pen
	| aPen |
	aPen := pen ifNil: [ Pen new ].
	aPen goto: self position. "Go where the turtle is with the pen"
	^ aPen! !

!TurtleMorph methodsFor: 'turtle' stamp: 'PhilippeBack 3/28/2012 17:27'!
penDown
	self pen down.! !

!TurtleMorph methodsFor: 'turtle' stamp: 'PhilippeBack 3/28/2012 17:28'!
penUp
	self pen up.! !

!TurtleMorph methodsFor: 'example' stamp: 'RJH 4/15/2008 02:57'!
square: size
	4 timesRepeat: [
		self forward: size.
		self turn: 90]! !

!TurtleMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 17:22'!
tilt
  ^ tilt ifNil: [0]! !

!TurtleMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 17:29'!
turn: anAngle
  tilt := anAngle.
  ^tilt! !

!TurtleMorph methodsFor: 'system' stamp: 'rjh 3/12/2010 01:24'!
turtleForm
	"Original file: turtle.png"
	^ Form
		extent: 33 @ 36
		depth: 32
		fromArray:   #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 0 0 0 0 0 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 4284734976 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 4284734976 4284734976 4284734976 4284734976 4292240128 4292240128 4284734976 4284734976 4284734976 4284734976 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292240128 4292240128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
		offset: 0 @ 0
! !

BorderedMorph subclass: #HOLOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-LightsOut'!

!HOLOGame methodsFor: 'accessing' stamp: 'PhilippeBack 3/30/2012 16:30'!
cellsPerSide
	^10.! !

!HOLOGame methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/30/2012 16:23'!
initialize
	| n sampleCell width height |
	super initialize.
	n := self cellsPerSide.
	sampleCell := HOLOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: (width+n)@(height+n)+(2*self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j | self newCellAt: i at: j].
	! !

!HOLOGame methodsFor: 'accessing' stamp: 'PhilippeBack 3/30/2012 16:47'!
newCellAt: i at: j
 | c origin|
 c := HOLOCell new.
 origin := self innerBounds origin.
 self addMorph: c.
 c position: ((i-1)* c width)@((j-1)*c height)+origin.
 c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
 ^c 
! !

!HOLOGame methodsFor: 'accessing' stamp: 'PhilippeBack 3/30/2012 16:48'!
toggleNeighboursOfCellAt: i at: j
  (i > 1) ifTrue: [(cells at: i-1 at: j) toggleState].
  (i < self cellsPerSide) ifTrue: [(cells at: i+1 at: j) toggleState].
  (j > 1) ifTrue: [(cells at: i at: j-1) toggleState].
  (j < self cellsPerSide) ifTrue: [(cells at: i at: j+1) toggleState].

  
! !

BorderedMorph subclass: #HOPRApp
	instanceVariableNames: 'container toolbar answerarea partsarea exercisearea titlebar trashcan helpicon verifyicon clearanswericon soundsystem nexticon exerciseSet exercise exerciseType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRApp commentStamp: 'PhilippeBack 7/12/2012 17:50' prior: 0!
Application des produits remarquables  destination de l'iPad

Currently a god class (ahem..)

Protocols:
accessing: provides what is required to build the UI
	Has a toolbar full of icons to work things out.
	There is also soundsystem in there so that we can have sound out of actions.
	
tools: contains all the needed selectors for building the icons of the toolbar.

actions: provides all the needed selectors for dealing with the action triggered by the icons.

Tools start actions
!

!HOPRApp class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 21:24'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'Produits Remarquables')
	       icon: UITheme current solidMenuIcon;
			parent: #'root';
			action: [self new openInWorld.].! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 00:43'!
answerarea
	^ answerarea
		ifNil: [ 
			answerarea :=  HOPRAnswerArea new.
			^answerarea.
		]! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/15/2012 23:24'!
clearAnswer
   self answerarea submorphs do: [:each | each delete].
   soundsystem play: #clearAnswer.
   self answerarea color: HOPRConfiguration answerAreaColor.
   ^self! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 7/13/2012 00:36'!
clearanswericon
	^ clearanswericon
		ifNil: [ 
			clearanswericon := IconicButton new.
			clearanswericon borderColor: Color transparent; color: Color transparent.
			clearanswericon labelGraphic: HOPRConfiguration eraserForm.	"clearanswericon label: 'Effacer Rponse'."
			clearanswericon actionSelector: #clearAnswer.
			clearanswericon target: self.
			^ clearanswericon ]! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/14/2012 01:19'!
container
	"stick a container in the window so that we can easily work in there"

	^ container
		ifNil: [ 
			container := Morph new.
			container color: Color white.
			container
				layoutPolicy: TableLayout new;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				listDirection: #bottomToTop.	"Now we can work"
			
			self addMorph: container.	"	window announcer
				on: WindowResizing
				do: [ :ann | 
					self storyarea extent: ann newSize.
					self textarea extent: ann newSize.
					self toolbar extent: ann newSize.
					self partsarea extent: ann newSize.
					].
		"
			container ]! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 11:20'!
evaluateAnswer
	| userAnswerText |

	Transcript nextPutAll: 'Evaluating Answer';cr.
	
	userAnswerText := self answerarea contents.
	
	Transcript nextPutAll: 'exercise:', exercise problem; cr;
	                 nextPutAll: 'useranswer:',userAnswerText;cr.
	Transcript endEntry.
	self flag: #TODO. "Must be evaluated"
	
      (exercise isValid: userAnswerText) ifTrue: [
	   self answerarea color: Color green.
	   self soundsystem play: #rightAnswer.
	] ifFalse: [
	   self answerarea color: Color red.
	   self soundsystem play: #wrongAnswer.
	]
! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/12/2012 22:54'!
exercisearea
	^ exercisearea
		ifNil: [ 
			"textarea := RectangleMorph new."

	          | textmorph |
			exercisearea := HOPRExerciseArea new.
			
			^exercisearea
			 ]! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 7/13/2012 00:36'!
helpicon

	^ helpicon
			ifNil: [ 
			helpicon :=  IconicButton new.
			helpicon borderColor: Color transparent; color: Color transparent.
			"verifyicon label: 'Vrifier'."
			helpicon labelGraphic: (HOPRConfiguration helpForm).
			helpicon actionSelector: #showhelp.
			helpicon target: self.
			^ helpicon
		]! !

!HOPRApp methodsFor: 'initialize-release' stamp: 'PhilippeBack 7/13/2012 00:26'!
initialize
	| filler |
	super initialize.
	
	self soundsystem.
	
	"self title: 'Produits Remarquables'."
	self color: Color tan.
	self layoutPolicy: TableLayout new;
				hResizing: #spaceFill;
				vResizing: #shrinkWrap;
				listDirection: #topToBottom.
	self addMorph: self trashcan.
	self addMorph: self partsarea.
	self addMorph: self answerarea.
	self addMorph: self exercisearea.
	self addMorph: self toolbar.
	filler := Morph new.
	filler height: 120; color: Color transparent.
	self addMorph: filler.
	self addMorph: self titlebar.
	
	exerciseType := #type1.
	self makeExerciseSet.
	
	self exercisearea contents: (exercise problem).
	 
	"window is created in a lazy way, when accessed."
	self extent: 1024@768.
	"self position: 0@0.
	self extension sticky: true.
	"
     self flag: #TODO. "Disable moving the window around."
	^self! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:14'!
makeExerciseSet
	exerciseSet := HOPRExerciseSet ofType: exerciseType.
	exercise := exerciseSet first! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:48'!
narrowIconExtent
	^ 30 @ 96! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 14:14'!
next

	exercise := exerciseSet next.
	
	exercise ifNil: [
		UITheme current inform: 'End of exercises!!'.
	 ] ifNotNil: [
		self exercisearea contents: exercise problem.
            self exercisearea changed.
	]
	
! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:48'!
nexticon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '->'.	"icon labelGraphic: (HOPRConfiguration verifyForm)."
	icon actionSelector: #next.
	icon extent: self narrowIconExtent.
	icon target: self.
	nexticon := icon.
	^ nexticon! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/11/2012 23:30'!
partsarea

	^ partsarea
		ifNil: [ 
			partsarea := HOPRPartsArea new.
			^ partsarea	
		]! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/6/2012 00:15'!
quit
   Transcript nextPutAll:'Quitting';cr.
	self shouldBeImplemented.! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:44'!
raz
	self makeExerciseSet.
	self flag: #TODO.	"Check for the end of the exercise set"
	self exercisearea contents: exercise problem.
	self exercisearea changed! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:48'!
razicon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: 'RAZ'.	"icon labelGraphic: (HOPRConfiguration verifyForm)."
	icon actionSelector: #raz.
	icon target: self.
	icon extent: self narrowIconExtent.
	nexticon := icon.
	^ nexticon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/15/2012 21:50'!
showhelp
	"Overlays a transparent form with details over the screen. Dismiss it on click."

	| overlay |
	"UITheme current inform: 'Help asked.'."
	overlay := HOPRHelpOverlay new.
	
	World addMorphFront: overlay.
	! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/15/2012 23:26'!
soundsystem
      
	^ soundsystem ifNil: [
	    soundsystem := HOPRSoundSystem new.
	]! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/12/2012 23:06'!
titlebar
	^ titlebar
		ifNil: [ 
			titlebar :=  HOPRTitlebar new.
			^titlebar
		]! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 7/13/2012 00:34'!
toolbar
	^ toolbar
		ifNil: [ 
			toolbar := Morph new.
			toolbar color: Color transparent.
			toolbar layoutPolicy: TableLayout new;
						hResizing: #shrinkWrap;
						vResizing: #shrinkWrap;
						listDirection: #rightToLeft.
			#(#verifyicon #clearanswericon #helpicon #nexticon #razicon #type1icon #type2icon #type3icon #type4icon #type5icon #type6icon #type7icon) do: [ :each | toolbar addMorph: (self perform: each)].
						
			^toolbar
		 ]! !

!HOPRApp methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 00:09'!
trashcan
	^ trashcan
		ifNil: [ 
			trashcan :=  HOPRTrashcan new.
			^trashcan.
		]! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:50'!
type1
	exerciseType := #type1.
	self raz.! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:48'!
type1icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '1'.
	icon actionSelector: #type1.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:50'!
type2
	exerciseType := #type2.
	self raz.! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:49'!
type2icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '2'.
	icon actionSelector: #type2.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:52'!
type3
	exerciseType := #type3.
	self raz.
	UITheme current inform: 'Pas de symboles supports pour le moment...'! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:49'!
type3icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '3'.
	icon actionSelector: #type3.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:51'!
type4
	exerciseType := #type4.
	self raz.! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:49'!
type4icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '4'.
	icon actionSelector: #type4.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:51'!
type5
	exerciseType := #type5.
	self raz.! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:49'!
type5icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '5'.
	icon actionSelector: #type5.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:51'!
type6
	exerciseType := #type6.
	self raz.! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:49'!
type6icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '6'.
	icon actionSelector: #type6.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'actions' stamp: 'PhilippeBack 6/24/2012 21:51'!
type7
	exerciseType := #type7.
	self raz.! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 6/24/2012 21:49'!
type7icon
	| icon |
	icon := SimpleButtonMorph new.
	icon label: '7'.
	icon actionSelector: #type7.
	icon target: self.
	icon extent: self narrowIconExtent.
	^ icon! !

!HOPRApp methodsFor: 'icons' stamp: 'PhilippeBack 7/13/2012 00:35'!
verifyicon

	^ verifyicon
			ifNil: [ 
			verifyicon := IconicButton new.
			verifyicon borderColor: Color transparent.
			verifyicon color: Color transparent.
			"verifyicon label: 'Vrifier'."
			verifyicon labelGraphic: (HOPRConfiguration verifyForm).
			verifyicon actionSelector: #evaluateAnswer.
			verifyicon target: self.
			^ verifyicon
		]! !

Pen subclass: #HOTurtlePen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Turtle'!

!HOTurtlePen commentStamp: 'PhilippeBack 3/30/2012 21:37' prior: 0!
A turtle pen with additional commands.
"Turtle Fun"
t := HOTurtlePen new.
t init.
t init; square.
t init; squarePiece: 200.

t init.
10 timesRepeat: [t init. t square.].
10 to: 300 by: 20 do: [:each |  t squarePiece: each].

t init; triangle.
t init; thing2.
t init; rectangleWithSide: 100 andSide: 400.

t init; circle.
t init; arcR: 2 andDegrees: 40.
t init. 6 timesRepeat: [ t petal: 5; right: 60].
t init; flower: 3.

t init; randomMoveWith: (-4) with: 4 with: (-5) with: 5.
!

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:57'!
arcR: r andDegrees: deg
  deg timesRepeat: [
	self forward: r;
	right: 1]! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 19:54'!
back: aDistance
  ^self go: (aDistance negated)! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:48'!
circle

  360 timesRepeat: [
	self forward: 1; right: 1.
  ]! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 21:04'!
flower: size

6 timesRepeat: [ self petal: size; right: 60].! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 19:54'!
forward: aDistance
  ^self go: aDistance! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 20:13'!
init
  "Places the turtle at the hand position with default properties"
  self place: ActiveHand position.
  self north.
  self defaultNib: 4.
  self color: Color green.! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 19:53'!
left: anAngle
  ^self turn: (anAngle negated)! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 19:58'!
penDown
  ^self down! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 19:58'!
penUp 
  ^self up! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:59'!
petal: size

self arcR: size andDegrees: 60.
self right: 120.
self arcR: size andDegrees: 60.
self right: 120.! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 21:28'!
randomBetween: low and: high

   ^(low + ((high-low) atRandom)).! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 21:36'!
randomMoveWith: o1 with: o2 with: a1 with: a2
  | n |
n := 500.
  n timesRepeat: [
    self left: (self randomBetween: a1 and: a2).
    self forward: (self randomBetween: o1 and: o2)
  ]
  ! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:34'!
rectangleWithSide: side1 andSide: side2
  self penDown.
  2 timesRepeat: [
	self squarePiece: side1.
	self squarePiece: side2.
	]! !

!HOTurtlePen methodsFor: 'turtle-basic' stamp: 'PhilippeBack 3/30/2012 19:52'!
right: anAngle
  ^self turn: anAngle! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:11'!
square
  self penDown;
		forward: 100;
		right: 90;
		forward: 100;
		right: 90;
		forward: 100;
		right: 90;
		forward:100.! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:32'!
squarePiece: sideSize

	self forward: sideSize;
		  right: 90.	! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:31'!
squareWithPiece: sideSize

  self penDown.
  4 timesRepeat: [
		self squarePiece: sideSize.
  ]! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:22'!
squareWithRepeat

  self penDown.
  4 timesRepeat: [
			self forward: 100;
		   right: 90.	
  ]! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:43'!
thing
  self 
forward: 100; 
right: 90; 
forward: 100; 
right: 90;
forward: 50;
right: 90;
forward: 50;
right: 90;
forward: 100;
right: 90;
forward: 25;
right: 90;
forward: 25;
right: 90;
forward: 50.

! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:44'!
thing1

  4 timesRepeat: [
	self thing
  ]! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:45'!
thing2

  20 timesRepeat: [
	self thing; right: 10; forward: 50.
  ]! !

!HOTurtlePen methodsFor: 'turtle-programs' stamp: 'PhilippeBack 3/30/2012 20:39'!
triangle

"TRIANGLE
REPEAT 3
  FORWARD 100
  RIGHT 120"

  3 timesRepeat: [
	self forward: 100.
	self right: 120.
  ]! !

PolygonMorph subclass: #Box
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Boxes'!

!Box commentStamp: 'PhilippeBack 4/15/2012 22:38' prior: 0!
Box class to demo Joe and Jill.!

!Box methodsFor: 'player commands' stamp: 'AndrewBlack 10/5/2009 14:49'!
grow: increment
	self extent: (self extent + increment)! !

!Box methodsFor: 'player commands' stamp: 'AndrewBlack 10/5/2009 14:54'!
hide
	self delete! !

!Box methodsFor: 'initialization' stamp: 'apb 1/6/2007 19:10'!
initialize
	"initialize this PolygonMorph so that it looks like a Box in BoxWorld"
	| corners |
	corners := (Rectangle origin: 85 @ 100 extent: 80 @ 80) corners.
	smoothCurve := false.
	self
		vertices: corners
		color: Color transparent
		borderWidth: 2
		borderColor: Color black! !

!Box methodsFor: 'player commands' stamp: 'apb 1/6/2007 19:27'!
move: aPointIncrement
	self position: self position + aPointIncrement! !

!Box methodsFor: 'player commands' stamp: 'AndrewBlack 10/5/2009 14:51'!
moveTo: aPoint
	self position: aPoint! !

!Box methodsFor: 'geometry' stamp: 'AndrewBlack 10/5/2009 14:51'!
position: aPoint
	super position: aPoint.
	self changed! !

!Box methodsFor: 'player commands' stamp: 'AndrewBlack 10/5/2009 14:54'!
show
	self openInWorld! !

!Box methodsFor: 'stepping and presenter' stamp: 'AndrewBlack 10/14/2009 15:58'!
stepTime 
	^500! !

!Box methodsFor: 'player commands' stamp: 'AndrewBlack 10/5/2009 14:48'!
turn: degrees 
	self rotationDegrees: (self rotationDegrees + degrees).
	self changed! !

!Box methodsFor: 'player commands' stamp: 'apb 1/6/2007 19:16'!
undraw
	self delete! !

Box subclass: #NamedBox
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Boxes'!

!NamedBox class methodsFor: 'instance creation' stamp: 'apb 1/6/2007 19:31'!
named: aName 
	| newBox |
	newBox := self new.
	newBox name: aName.
	^ newBox! !

!NamedBox methodsFor: 'accessing' stamp: 'apb 1/6/2007 22:38'!
name: aName 
	name := aName.
	self addMorphCentered: (TextMorph new contents: aName asText allBold).
	^ aName
	! !

RectangleMorph subclass: #HOAstroidMorph
	instanceVariableNames: 'nombreDeDroites longueur drawingColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOAstroidMorph commentStamp: 'PhilippeBack 3/11/2012 08:40' prior: 0!
An Astroid shaped Morph.

Description:
  This class demonstrates an astroid mathematical object.

Collaborations: Canvas

Usage:
  (AstroidMorph new) openInWorld.
!

!HOAstroidMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:44'!
example
	|m|
	
	m := HOAstroidMorph new openInWorld.
	
! !

!HOAstroidMorph methodsFor: 'drawing' stamp: 'PhilippeBack 3/10/2012 17:22'!
areasRemainingToFill: aRectangle
	"Could be improved by quick check of inner rectangle"

	^ Array with: aRectangle! !

!HOAstroidMorph methodsFor: 'private' stamp: 'PhilippeBack 1/2/2011 20:47'!
configureLongueur: aLongueur etNombreDeDroites: aNombreDeDroites
  longueur :=  aLongueur.
  nombreDeDroites := aNombreDeDroites.
  drawingColor := Color red.
! !

!HOAstroidMorph methodsFor: 'initialization' stamp: 'PhilippeBack 3/10/2012 17:51'!
degrees: aNumber
"Do nothing"! !

!HOAstroidMorph methodsFor: 'drawing' stamp: 'PhilippeBack 3/18/2012 22:11'!
drawOn: aCanvas

  | t xa xc xb yc ya yb |

    "super drawOn: aCanvas."
    
    xc := self left + (self bounds width / 2).
   yc := self top + (self bounds height / 2).
   
  ya := yc.
  xb := xc.

  "aCanvas line: (self topLeft) to: xc@yc color: Color green."

0 to: (longueur - 1) do: [:i | t := (2* (Float pi) * i) / nombreDeDroites.
	xa := xc + (longueur * t cos).
	yb := yc + (longueur * t sin).
	
	aCanvas line: (xa@ya) to: (xb@yb) color: self color.
	]
   



! !

!HOAstroidMorph methodsFor: 'drawing' stamp: 'PhilippeBack 3/10/2012 17:49'!
extent: aPoint
"Do nothing"! !

!HOAstroidMorph methodsFor: 'initialization' stamp: 'PhilippeBack 3/10/2012 17:49'!
initialize
  super initialize.
  super extent: 500@500.
  self configureLongueur:  ((self width) /2)+10 etNombreDeDroites: 50.
  "We need to put some extra to avoid ugly trails left by the +10 in the morph."
  super extent: 520@520.


! !

RectangleMorph subclass: #HOKeyboardHandlingMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOKeyboardHandlingMorph class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:47'!
example
  HOKeyboardHandlingMorph new openInWorld.! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:45'!
handlesKeyboard: evt
   ^ true
! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:51'!
keyDown: anEvent
"Handle a key down event. ."
  anEvent keyCharacter = $a
     ifTrue: [self doSomething].
  anEvent keyCharacter = $q
     ifTrue: [self doAnotherOne]! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:45'!
mouseEnter: evt
   evt hand keyboardFocus: self ! !

!HOKeyboardHandlingMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 21:45'!
mouseLeave: evt
   evt hand releaseKeyboardFocus: self ! !

RectangleMorph subclass: #HOPRAnswerArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRAnswerArea commentStamp: 'PhilippeBack 7/12/2012 17:42' prior: 0!
HOPRAnswerArea represents the answer area on which parts of the answer are dropped.!

!HOPRAnswerArea methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 10:56'!
contents
	| answertext |
	self flag: #TODO. "must implement"

     answertext := String new.
     self submorphs do: [:each | answertext := answertext , each contents. ].
	^answertext! !

!HOPRAnswerArea methodsFor: 'initialization' stamp: 'PhilippeBack 7/13/2012 00:22'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new;
			listDirection: #leftToRight;
			hResizing: #spaceFill; "Fill the owner"
			vResizing: #shrinkWrap; "Wrap according to the children"
			layoutInset: 20; 
			cellInset: 2.
	self height: 88.
	self color: HOPRConfiguration answerAreaColor.
    self enableDragNDrop.! !

!HOPRAnswerArea methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/12/2012 23:11'!
wantsDroppedMorph: aMorph event: anEvent 
    "tests if compatible" "^aMorph color = Color yellow."
    self flag: #FIXME. "Accepts anything at this time"
    ^true
! !

RectangleMorph subclass: #HOPRExerciseArea
	instanceVariableNames: 'contents contentsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRExerciseArea commentStamp: 'PhilippeBack 7/12/2012 17:43' prior: 0!
HOPRExerciseArea represents the area that shows an exercise.!

!HOPRExerciseArea methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 10:42'!
contents
	^ contents.! !

!HOPRExerciseArea methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 23:29'!
contents: aString
   contents := aString.
   contentsMorph contents: contents.
   contentsMorph changed.! !

!HOPRExerciseArea methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:18'!
contentsMorph
  | font |
^contentsMorph ifNil: [
	   contentsMorph := StringMorph new.
	   contentsMorph font: (HOPRConfiguration font:24).
	   contentsMorph color: HOPRConfiguration exerciseAreaForegroundColor.
	   ^contentsMorph.
	]! !

!HOPRExerciseArea methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 23:02'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new;
			listDirection: #leftToRight;
			hResizing: #spaceFill; "Fill the owner"
			vResizing: #shrinkWrap; "Wrap according to the children"
			layoutInset: 20; 
			cellInset: 10.
	self height: 300.
	self addMorph: self contentsMorph.
	self contents:  ''.
	self color: HOPRConfiguration exerciseAreaColor.! !

RectangleMorph subclass: #HOPRPartsArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRPartsArea commentStamp: '<historical>' prior: 0!
Represents a parts bin with numbers and operators.!

!HOPRPartsArea methodsFor: 'initialize-release' stamp: 'PhilippeBack 7/15/2012 01:20'!
initialize
	| m frame row1 row2 |
	super initialize.
	self enableDragNDrop.
	self
		color: HOPRConfiguration partsAreaColor;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutInset: 10;
		cellInset: 2;
		height: 80.	"Fill the owner"	"Wrap according to the children"
	row1 := Morph new
		layoutPolicy: TableLayout new;
		listDirection: #rightToLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutInset: 10;
		cellInset: 5.
		
	row2 := Morph new
		layoutPolicy: TableLayout new;
		listDirection: #rightToLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutInset: 10;
		cellInset: 5.	

	self addMorph: row1.
	self addMorph: row2.

	self symbols
		do: [ :each | 
			| s |
			m := HOPRPart symbol: each asString.
			row1 addMorph: m.
			].
	self symbols2
		do: [ :each | 
			| s |
			m := HOPRPart symbol: each asString as: #exponent.
			row2 addMorph: m.
			]
	
		
	! !

!HOPRPartsArea methodsFor: 'initialize-release' stamp: 'PhilippeBack 7/15/2012 01:32'!
symbols
  ^#( $0 $1 $2 $3 $4 $5 $6 $7 $8 $9 $( $) $+ $- $* $/  $x $y  )! !

!HOPRPartsArea methodsFor: 'initialize-release' stamp: 'PhilippeBack 6/13/2012 22:36'!
symbols2
  ^#($0 $1 $2 $3 $4 $5 $6 $7 $8 $9)! !

RectangleMorph subclass: #HOPRTimer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRTimer commentStamp: 'PhilippeBack 7/12/2012 17:44' prior: 0!
HOPRTimer takes care of managing the timing of an exercise.!

RectangleMorph subclass: #HOPRTitlebar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRTitlebar commentStamp: 'PhilippeBack 7/12/2012 17:45' prior: 0!
HOPRTitlebar represents the title bar of the application.
Currently a single piece of text, should become much nicer later.!

!HOPRTitlebar methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:46'!
initialize
	| s |
	super initialize.
	s := StringMorph new.
	s contents: 'PRODUITS REMARQUABLES'.
	s color: HOPRConfiguration titlebarColor.
	s font: HOPRConfiguration titlebarFont.
	self color: HOPRConfiguration titlebarBackgroundColor.
      self addMorph: s.  
      self extent: 1024@40.
      self flag: #FIXME "Add support for the font size and style or put a picture in there."! !

RectangleMorph subclass: #HOPRTrashcan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRTrashcan commentStamp: 'PhilippeBack 7/12/2012 17:45' prior: 0!
HOPRTrashcan is where one can drop parts that are no longer wanted.!

!HOPRTrashcan methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/13/2012 00:30'!
initialize
	| trashIcon |
	super initialize.
	self color: HOPRConfiguration trashColor.
	self changed.
	self
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		wrapDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutInset: 0;
		cellInset: 0.	"Fill the owner"	"Wrap according to the children"
	self height: 160.
	trashIcon := IconicButton new.
	trashIcon color: Color transparent.
	trashIcon borderColor: Color transparent.
	trashIcon labelGraphic: HOPRConfiguration trashForm.

	self addMorphFront: trashIcon! !

!HOPRTrashcan methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 00:26'!
wantsDroppedMorph: aMorph event: anEvent 
    "tests if compatible" "^aMorph color = Color yellow."
    self flag: #FIXME. "Accepts anything at this time"
    ^true
! !

RectangleMorph subclass: #HOTestMorph
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTestMorph commentStamp: 'PhilippeBack 3/10/2012 17:34' prior: 0!
A test morph that moves and react to the mouse.

HOTestMorph new openInWorld.!

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:33'!
drawOn: aCanvas
    | colors |
    colors := Color wheel: 10.
    colors withIndexDo: [:c :i |
        aCanvas fillOval: (self bounds insetBy: self width // 25 * i + 1)
                color: c].
! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:33'!
handlesMouseDown: evt
    ^ true
! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:31'!
initialize
    super initialize.
    path := OrderedCollection new.! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:36'!
mouseDown: evt
    self startAnimation.! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:33'!
startAnimation
    path := OrderedCollection new.
    0 to: 29 do: [:i | path add: self position + (0@(i squared / 5.0))].
    path := path, path reversed.
    self startStepping.! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:32'!
step
    path size > 0 ifTrue: [self position: path removeFirst].! !

!HOTestMorph methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/10/2012 17:32'!
stepTime
    ^ 50! !

TestCase subclass: #AstroidMorphTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Tests'!

!AstroidMorphTests methodsFor: 'testing' stamp: 'PhilippeBack 3/10/2012 17:18'!
testHowToDoAnAssert
	| data |
	data := True.
	self assert: data.! !

TestCase subclass: #HOBenchmarking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Tests'!

!HOBenchmarking class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/30/2012 17:18'!
benchmark1
  5 timesRepeat: [Transcript show: 0 tinyBenchmarks; cr].! !

!HOBenchmarking class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/30/2012 18:21'!
benchmark2
  5 timesRepeat: [Transcript show: 0 tinyBenchmarks; cr].! !

SystemWindow subclass: #HOPRWindow
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRWindow commentStamp: 'PhilippeBack 7/12/2012 17:38' prior: 0!
Useful window to work with HOPRApp in a Pharo desktop development environment.

Invoke with 

HOPRWindow openInWorld.!

!HOPRWindow class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/12/2012 17:41'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'Produits Remarquables Window')
	       icon: UITheme current solidMenuIcon;
			parent: #'root';
			action: [HOPRWindow openInWorld.].! !

!HOPRWindow class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/14/2012 12:12'!
openInWorld
   HOPRWindow new model: (HOPRWindowModel new); openInWorld: ActiveWorld extent: (1024@768).! !

!HOPRWindow methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/12/2012 15:38'!
initialize
      | m |
super initialize.
	self setLabel: 'Produits Remarquables'.
	
	self addMorph: (container := Morph new) frame: (0 @ 0 corner: 1 @ 1).
	container
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight.	"Now we can work..."
	
	m := HOPRApp new.

	container addMorph: HOPRApp new.
	container extent: 500@768.
	^self
! !

Object subclass: #HOCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

HOCounter class
	instanceVariableNames: 'count'!

HOCounter class
	instanceVariableNames: 'count'!

!HOCounter class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:20'!
new
  "The usual stanza"
  ^super new initialize! !

!HOCounter class methodsFor: 'instance creation' stamp: 'PhilippeBack 3/28/2012 12:30'!
openInWorld 
  "Just a shorthand for getting something out of the class."
  ^self new openInWorld.! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:32'!
add: amount
	count := count + amount.
	self changed: #printString! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:33'!
count: aNumberOrText
	count := aNumberOrText asNumber.
	^ true! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:33'!
decrease
	self add: -1! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:34'!
increase
	self add: 1! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:34'!
initialize
	count := 0! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:34'!
openInWorld
	| window increaseButton decreaseButton display |
	window := SystemWindow labelled: 'Counter'.
	window model: self.
	increaseButton := PluggableButtonMorph new
		model: self;
		action: #increase;
		label: 'Increase';
		borderWidth: 1.
	decreaseButton := PluggableButtonMorph new
		model: self;
		action: #decrease;
		label: 'Decrease';
		borderWidth: 1.
	display := PluggableTextMorph on: self text: #printString accept: #count:.
	window addMorph: display frame: (0 @ 0 extent: 1 @ 0.5).
	window addMorph: increaseButton frame: (0 @ 0.5 extent: 0.5 @ 0.5).
	window addMorph: decreaseButton frame: (0.5 @ 0.5 extent: 0.5 @ 0.5).
	window openInWorld! !

!HOCounter methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:31'!
printOn: aStream
  aStream nextPutAll: count printString! !

Object subclass: #HOKMDebuggerShortcuts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Keymappings'!

!HOKMDebuggerShortcuts commentStamp: 'PhilippeBack 6/17/2012 14:47' prior: 0!
HOKMDebuggerShortcuts provides support for key based debugging actions. See class side for the details of the keys.!

!HOKMDebuggerShortcuts class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/17/2012 15:30'!
buildDebuggerShortcutsOn: aBuilder
	<keymap>
	(aBuilder shortcut: #stackDown)
		category: #HODebuggerShortcuts "Will not activate since the HO Prefix."
		default: $d command shift , Character arrowDown
		do: [ :target | target down ].
	(aBuilder shortcut: #stackUp)
		category: #DebuggerShortcuts
		default: $d command shift , Character arrowUp
		do: [ :target | target up ].
	(aBuilder shortcut: #proceedDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $p
		do: [ :target | target proceed ].
	(aBuilder shortcut: #restartDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $r
		do: [ :target | target	restart ].
	(aBuilder shortcut: #stepIntoDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $i
		do: [ :target |	target	send ].
	(aBuilder shortcut: #stepOverDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $o
		do: [ :target | target	doStep ].
	(aBuilder shortcut: #stepIntoBlockDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $t
		do: [ :target | 	target	stepIntoBlock ].
	(aBuilder shortcut: #SeeFullStackDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $f
		do: [ :target | 	target fullStack ].
	(aBuilder shortcut: #runHereDebugger)
		category: #DebuggerShortcuts
		default: $d command shift , $h
		do: [ :target | 	target	runToSelection ]! !

Object subclass: #HOLivreHeros
	instanceVariableNames: 'story window toolbar storyarea dicearea textarea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHeros commentStamp: 'PhilippeBack 3/19/2012 22:00' prior: 0!
Runs a story.!

!HOLivreHeros class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/19/2012 13:23'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'HOLivreHeros')
	       icon: UITheme current solidMenuIcon;
			parent: #'High Octane Experiments';
			action: [self new.].! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 23:08'!
dicearea
	^ dicearea
		ifNil: [ 
			| area |
			area :=  RectangleMorph new.
			dicearea:=area.
		]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 6/11/2012 23:50'!
exercise
	^ textarea
		ifNil: [ 
			"textarea := RectangleMorph new."

	          | textmorph |
			textmorph := PluggableTextMorph new
				on: self
				text: nil
				accept: nil
				readSelection: nil
				menu: nil.
			textmorph setText: 'Hello world'.
			textarea := textmorph ]! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 6/11/2012 23:50'!
initialize
	super initialize.
	
	self installToolbar.
	self installTextArea.
	self installStoryArea.
	self installDiceArea.

    self exercise textMorph color: Color red.
    self dicearea color: Color yellow.
    self storyarea color: Color magenta.

    self exercise.

	"window is created in a lazy way, when accessed."
	self window openInWorld.
	"self window  extent: 300@250"! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:05'!
installDiceArea
	self window addMorph: self dicearea frame: (0 @ 0.90 corner: 1 @ 1)! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:11'!
installStoryArea

	self window 
		addMorph: self storyarea frame: (0@0.60 corner: 1@0.9)
		
! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 6/11/2012 23:50'!
installTextArea

    self window addMorph: self exercise frame: (0@0.10 corner: 1@0.60).
    
! !

!HOLivreHeros methodsFor: 'initialize-release' stamp: 'PhilippeBack 3/19/2012 23:00'!
installToolbar
	self window
		addMorph: self toolbar
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ self toolbar minExtent y))! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 6/11/2012 23:50'!
next
	self exercise editString: self story nextEpisode.
! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/19/2012 15:46'!
quit
   Transcript nextPutAll:'Quitting';cr.
	self shouldBeImplemented.! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/19/2012 15:47'!
rollDice
	Transcript nextPutAll: 'Rolling Dice';cr.
	self shouldBeImplemented.! !

!HOLivreHeros methodsFor: 'actions' stamp: 'PhilippeBack 3/19/2012 15:46'!
runbook
	Transcript nextPutAll: 'Running the book';cr.
	self shouldBeImplemented.! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/20/2012 00:11'!
story
	^ story ifNil: [ story := HOLivreHerosStory new ]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 3/19/2012 23:08'!
storyarea
	^ storyarea
		ifNil: [ 
			| area |
			area :=  RectangleMorph new.
			storyarea:=area.
		]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 6/5/2012 21:07'!
toolbar
	^ toolbar
		ifNil: [ 
			| tools |
			tools := self window
				newToolbar:
					{(self window
						newButtonFor: self
						getState: nil
						action: #runbook
						arguments: nil
						getEnabled: nil
						labelForm: (UITheme current smallDoItIcon scaledToSize: 16 @ 16)
						help: 'Run.').
					(self window
						newButtonFor: self
						getState: nil
						action: #next
						arguments: nil
						getEnabled: nil
						labelForm: (UITheme current smallForwardIcon scaledToSize: 16 @ 16)
						help: 'Forward').
					(self window
						newButtonFor: self
						getState: nil
						action: #quit
						arguments: nil
						getEnabled: nil
						labelForm: (UITheme current smallQuitIcon scaledToSize: 16 @ 16)
						help: 'Quit.')}.
			toolbar := self window newToolDockingBar addMorph: tools ]! !

!HOLivreHeros methodsFor: 'accessing' stamp: 'PhilippeBack 6/11/2012 23:50'!
window
	^ window
		ifNil: [ 
			window := StandardWindow labelled: 'High Octane Heros Book Runner'.	
			window announcer
				on: WindowResizing
				do: [ :ann | 
					self storyarea extent: ann newSize.
					self exercise extent: ann newSize.
					self toolbar extent: ann newSize.
					self dicearea extent: ann newSize.
					].
			window ]! !

Object subclass: #HOLivreHerosAction
	instanceVariableNames: 'title target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHerosAction commentStamp: 'PhilippeBack 3/20/2012 23:47' prior: 0!
Represents an action, formed of a text and a target number.!

!HOLivreHerosAction methodsFor: 'accessing' stamp: 'PhilippeBack 3/20/2012 23:46'!
target: aSmallInteger 
	target := aSmallInteger.! !

!HOLivreHerosAction methodsFor: 'accessing' stamp: 'PhilippeBack 3/20/2012 23:46'!
title: aByteString 
	title := aByteString.! !

HOLivreHerosAction subclass: #HOLivreHerosBattleAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHerosBattleAction commentStamp: 'PhilippeBack 3/20/2012 23:49' prior: 0!
Represents a battle action with various outcomes based on the final result. !

Object subclass: #HOLivreHerosStory
	instanceVariableNames: 'episodes currentEpisode episode1actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOLivreHerosStory commentStamp: 'PhilippeBack 3/20/2012 23:50' prior: 0!
Represents the logic and body of the story.

Instance Variables:
	episodes	<Collection>
	currentEpisode	<Number>
	episode1actions	<Collection>!

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:08'!
begin
  "start the story"
  currentEpisode = -1.
  ^self! !

!HOLivreHerosStory methodsFor: 'episodes' stamp: 'PhilippeBack 3/20/2012 23:14'!
episode1
  ^'Alors que vous parcourez comme tous les matins les quelques centaines de mtres qui vous sparent de votre bureau, vous ne pouvez vous dfendre d''un indfinissable malaise.'.! !

!HOLivreHerosStory methodsFor: 'episodes' stamp: 'PhilippeBack 3/20/2012 23:58'!
episode1actions
  ^episode1actions ifNil: [ 
	  episode1actions := OrderedCollection new.
	  
	episode1actions add: (self newEpisodeActionWithTitle: 'Vous diriger vers le groupe pour tenter d''arrter la dispute?' andTarget:263 ).
	episode1actions add: (self newEpisodeActionWithTitle: 'Vous prcipiter vers le parc des Bogues  la suite de la voiture de police?' andTarget:289 ).
	episode1actions add: (self newEpisodeActionWithTitle: 'Acheter le journal pour avoir des dtail sur le cambriolage?' andTarget:228 ).
	episode1actions add: (self newEpisodeActionWithTitle: 'Continuer votre chemin jusqu'' votre bureau?' andTarget:341 ).
	
	  episode1actions.
	]! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:35'!
initialize
  currentEpisode := 0. 
  episodes := OrderedCollection new.
  #('One upon a time...' 'There was a dragon...' 'And  a lot of other people.' 'But this will be for another time') do: [:each| episodes add: each].
 
  
! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:07'!
isFinished
  "Tells if the story is over"
  ^currentEpisode = episodes size.! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 23:45'!
newEpisodeActionWithTitle: aByteString andTarget: aSmallInteger 
	| action |
	action := HOLivreHerosAction new.
	action title: aByteString; target: aSmallInteger.
	^action ! !

!HOLivreHerosStory methodsFor: 'initialization' stamp: 'PhilippeBack 3/20/2012 00:34'!
nextEpisode
	( currentEpisode < episodes size )
		ifTrue: [ currentEpisode :=currentEpisode + 1 ]
		ifFalse: [ currentEpisode := currentEpisode ].
	^ episodes at: currentEpisode! !

Object subclass: #HOMenus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOMenus commentStamp: 'PhilippeBack 3/19/2012 08:55' prior: 0!
Sample class to show how to add elements to the World menu.
See Class side.

Also, it is interesting to have a look at MenuRegistrationExample, to be used with:

(PragmaMenuBuilder pragmaKeyword: 'worldMenuExample' model: nil) menu popUpInWorld.

The is a bug in the example. Replace the icon problem related line with:
UITheme current solidMenuIcon!

!HOMenus class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 21:30'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'High Octane Experiments')
	       icon: UITheme current solidMenuIcon;
			parent: #Root;
			with: [
			  (aBuilder item: #'About...') 
				  order: 0; 
				  action: [UITheme current messageIn: World	text: 'High Octane Rulez!!'	title: 'Experiments in Pharo'].
				(aBuilder item: #'HOAstroidMorph') 
				  order: 1; 
				  action: [HOAstroidMorph new openInWorld].
				(aBuilder item: #'HOCanvasMorph') 
				  order: 2; 
				  action: [HOCanvasMorph example].
				(aBuilder item: #'Theme switch to Vistary') 
				  order: 3; 
				  action: [UIThemeVistary beCurrent].
				(aBuilder item: #'Theme switch to Watery2') 
				  order: 4; 
				  action: [UIThemeWatery2 beCurrent.].
				(aBuilder item: #'Theme switch to GLMUI (pharo)') 
				  order: 5; 
				  action: [PharoTheme beCurrent.].
				(aBuilder item: #'Theme switch to GLMUI (orange pharo)') 
				  order: 6; 
				  action: [PharoOrangeTheme beCurrent.].
				(aBuilder item: #'Full Screen') 
				  order: 10; 
				  action: [Display fullscreenOn.].
				(aBuilder item: #'Windowed') 
				  order: 20; 
				  action: [Display fullscreenOff.].	
			].! !

Object subclass: #HOPRBadge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRBadge commentStamp: 'PhilippeBack 6/24/2012 14:22' prior: 0!
HOPRBadge represents a badge you can earn.!

Object subclass: #HOPRBinome
	instanceVariableNames: 'variables coefs exponents sign type dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRBinome commentStamp: 'PhilippeBack 6/24/2012 10:57' prior: 0!
HOPRBinome represents something like (ax^n + or - by^p)^2

One can ask for various types of HOPRBinome instances on the class side (makeType1 ...)

Then one can ask for the problem and also see if an answer may fit. (not yet implemented)


Instance Variables:
	variables	x,y,z
	coefs		a,b
	exponents	n,p
	sign		+/-!

!HOPRBinome class methodsFor: 'private' stamp: 'PhilippeBack 6/24/2012 13:00'!
coefValues
	| items |
	items := OrderedCollection new.
	2 timesRepeat: [ items add: (0 to: 21) atRandom - 10 ].
	^ items! !

!HOPRBinome class methodsFor: 'private' stamp: 'CatherineAbsil 6/24/2012 14:41'!
exponents
	| items |
	items := OrderedCollection new.
	2 timesRepeat: [ items add: (1 to: 15) atRandom  ].
	^ items! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 23:38'!
makeType1
	| b varnames sign |
	b := HOPRBinome new.
	b setType: #type1.
	
     varnames := self variableNames.
     sign := self pickSign.
	
	b setParameter: #var1 value: (varnames at: 1).
	b setParameter: #var2 value: (varnames at: 2).
	b setParameter: #sign value: sign.
	
	^b
	
	
	! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/25/2012 11:01'!
makeType2
	| b varnames coefs sign |
	b := HOPRBinome new.
	b setType: #type2.
	varnames := self variableNames.
	coefs := self coefs.
	sign := self pickSign.
	b setParameter: #var value: (varnames at: 1).
	b setParameter: #coef value: (varnames at: 2).
	b setParameter: #sign value: sign.
	^ b! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 21:22'!
makeType3
	| b |
	b := HOPRBinome new.
	b setType: #type3.
	b setVariableNames: self variableNames coefs: self coefValues exponents: self exponents sign: self pickSign.
	^b
	
	
	! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 21:22'!
makeType4
	| b |
	b := HOPRBinome new.
	b setType: #type4.
	b setVariableNames: self variableNames coefs: self coefValues exponents: nil sign: self pickSign.
	^b
	! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 21:22'!
makeType5
	| b |
	b := HOPRBinome new.
	b setType: #type5.
	b setVariableNames: self variableNames coefs: self coefValues exponents: nil sign: self pickSign.
	^b
	
	
	! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 21:22'!
makeType6
	| b |
	b := HOPRBinome new.
	b setType: #type6.
	b setVariableNames: self variableNames coefs: nil exponents: self exponents sign: self pickSign.
	^b
	
	
	! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 21:22'!
makeType7
	| b |
	b := HOPRBinome new.
	b setType: #type7.
	b setVariableNames: self variableNames coefs: self coefValues exponents: self exponents sign: self pickSign.
	^b
	
	
	! !

!HOPRBinome class methodsFor: 'instance creation' stamp: 'PhilippeBack 6/24/2012 18:02'!
makeTypeRef
	| b |
	b := HOPRBinome new.
	b setVariableNames: self variableNames coefs: self coefValues exponents: self exponents sign: self pickSign.
	^b
	
	
	! !

!HOPRBinome class methodsFor: 'private' stamp: 'PhilippeBack 6/24/2012 14:09'!
pickSign
   ^ #($+ $-) at: (2 atRandom)! !

!HOPRBinome class methodsFor: 'private' stamp: 'PhilippeBack 6/24/2012 20:28'!
variableNames
	| varlist i1 i2 |
	varlist := #($x $y $z $w).
	i1 := varlist size atRandom.
	i2 := varlist size atRandom.
	[i1 = i2] whileTrue: [ 
		i2 := varlist size atRandom.
	].
	^ Array with: (varlist at: i1) with: (varlist at: i2)! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 12:54'!
developments
	| developments |
	self flag: #TODO.	"Must provide developments collection"
	self flag: #TODO.	"Foresee caching for the results"
	developments := OrderedCollection new.
	developments add: '1+1'.
	developments add: '1+2'.
	^ developments! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 23:30'!
initialize
  dict := Dictionary new.! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 21:27'!
problem
	| stream aSelector |
	stream := String new writeStream.
	
	aSelector := (type, ':') asSymbol.
	self perform: aSelector with: stream.
		
	^ stream contents! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 23:31'!
setParameter: aKey value: aValue
  dict at: aKey put: aValue
! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 18:05'!
setType: aSymbol
  type := aSymbol
! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 00:54'!
setVariableNames: anArray coefs: anArray2 exponents: anArray3 sign: aCharacter 
	variables := anArray.
	coefs := anArray2.
	exponents:= anArray3.
	sign := aCharacter.
	^self! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 23:39'!
type1: stream
	stream
		nextPut: $(;
		nextPutAll: (dict at: #var1) asString;
		space;
		nextPut: (dict at: #sign);
		space;
		nextPutAll: (dict at: #var2) asString;
		nextPutAll: ')^2'.! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:34'!
type2: stream
	stream
		nextPut: $(;
		nextPutAll: (coefs at: 1) asString;
		space;
		nextPut: sign;
		space;
		nextPutAll: (variables at: 1) asString;
		nextPutAll: ')^2'! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:09'!
type3: stream
	stream
		nextPut: $(;
		nextPutAll: (coefs at: 1) asString;
		nextPutAll: (variables at: 1) asString;
		nextPut: $^;
		nextPutAll: (exponents at: 1) asString;
		space;
		nextPut: sign;
		space;
		nextPutAll: (coefs at: 2) asString;
		nextPutAll: (variables at: 2) asString;
		nextPut: $^;
		nextPutAll: (exponents at: 2) asString;
		nextPutAll: ')^2'! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:37'!
type4: stream
	stream
		nextPut: $(;
		nextPutAll: (coefs at: 1) asString;
		nextPutAll: (variables at: 1) asString;
		space;
		nextPut: sign;
		space;
		nextPutAll: (variables at: 2) asString;
		nextPutAll: ')^2'! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:39'!
type5: stream
	stream
		nextPut: $(;
		nextPutAll: (coefs at: 1) asString;
		nextPutAll: (variables at: 1) asString;
		space;
		nextPut: sign;
		space;
		nextPutAll: (coefs at: 2) asString;
		nextPutAll: (variables at: 2) asString;
		nextPutAll: ')^2'! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:39'!
type6: stream
	stream
		nextPut: $(;
		nextPutAll: (variables at: 1) asString;
		nextPut: $^;
		nextPutAll: (exponents at: 1) asString;
		space;
		nextPut: sign;
		space;
		nextPutAll: (variables at: 2) asString;
		nextPut: $^;
		nextPutAll: (exponents at: 2) asString;
		nextPutAll: ')^2'! !

!HOPRBinome methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:09'!
type7: stream
	stream
		nextPut: $(;
		nextPutAll: (coefs at: 1) asString;
		nextPutAll: (variables at: 1) asString;
		nextPut: $^;
		nextPutAll: (exponents at: 1) asString;
		space;
		nextPut: sign;
		space;
		nextPutAll: (coefs at: 2) asString;
		nextPutAll: (variables at: 2) asString;
		nextPut: $^;
		nextPutAll: (exponents at: 2) asString;
		nextPutAll: ')^2'! !

Object subclass: #HOPRConfiguration
	instanceVariableNames: ''
	classVariableNames: 'HelpOverlayForm PartHighLightTileForm PartNormalTileForm'
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRConfiguration commentStamp: 'PhilippeBack 6/13/2012 23:11' prior: 0!
configuration constants on the class side.!

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 10:18'!
answerAreaColor
  ^Color r: 0.7 g: 0.6 b: 0.1.! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 6/16/2012 00:59'!
eraserForm
   ^"PartHighLightTileForm ifNil: [PartHighLightTileForm :=" (ImageReadWriter formFromFileNamed: 'EraserIcon96x96.png')"]"! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 10:06'!
exerciseAreaColor
  ^Color magenta.! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:09'!
exerciseAreaForegroundColor
  ^Color white.! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:13'!
font: aSize
	| size |
	aSize ifNil: [ size := 12 ] ifNotNil: [ size := aSize ].
	^ StrikeFont familyName: StrikeFont dejaVuKey pointSize: size! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/16/2012 01:06'!
helpForm
   ^"PartHighLightTileForm ifNil: [PartHighLightTileForm :=" (ImageReadWriter formFromFileNamed: 'HelpIcon96x96.png')"]"! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 6/15/2012 21:55'!
helpOverlayForm
   ^HelpOverlayForm ifNil: [HelpOverlayForm :=(ImageReadWriter formFromFileNamed: 'HelpOverlay.png')]! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 23:25'!
highlightTileForm
   ^"PartHighLightTileForm ifNil: [PartHighLightTileForm :=" (ImageReadWriter formFromFileNamed: 'GreenTile40x40_High.png')"]"! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 6/13/2012 23:25'!
normalTileForm
   "^PartNormalTileForm ifNil: [PartNormalTileForm :="
	^(ImageReadWriter formFromFileNamed: 'GreenTile40x40.png')"]"! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 7/15/2012 01:17'!
partTextColor
	^Color yellow.! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 10:06'!
partsAreaColor
  ^Color cyan.! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 7/15/2012 01:38'!
titlebarBackgroundColor
	^Color black.! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:39'!
titlebarColor
  ^Color white.! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 7/15/2012 01:37'!
titlebarFont
   ^HOPRConfiguration font: 24.
	! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/13/2012 10:06'!
trashColor
  ^Color gray darker darker.! !

!HOPRConfiguration class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/16/2012 09:40'!
trashForm
   ^"PartHighLightTileForm ifNil: [PartHighLightTileForm :=" (ImageReadWriter formFromFileNamed: 'TrashIcon96x96.png')"]"! !

!HOPRConfiguration class methodsFor: 'accessing' stamp: 'PhilippeBack 6/16/2012 00:54'!
verifyForm
   ^"PartHighLightTileForm ifNil: [PartHighLightTileForm :=" (ImageReadWriter formFromFileNamed: 'VerifyIcon96x96.png')"]"! !

Object subclass: #HOPRExercise
	instanceVariableNames: 'binome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRExercise commentStamp: 'PhilippeBack 7/12/2012 17:43' prior: 0!
HOPRExercise represents and exercise to solve.!

!HOPRExercise class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 11:22'!
binome: aHOPRBinome 
   
	^self basicNew initialize setBinome: aHOPRBinome.! !

!HOPRExercise methodsFor: 'accessing' stamp: 'PhilippeBack 6/24/2012 11:40'!
isValid: aUserAnswer
  self flag: #TODO. "We will have to deal with ^ and other elements in the answer since we do not want ugly looks on screen."
  ^binome developments includes: aUserAnswer! !

!HOPRExercise methodsFor: 'instance-creation' stamp: 'PhilippeBack 6/24/2012 11:23'!
problem
  ^binome problem.! !

!HOPRExercise methodsFor: 'instance-creation' stamp: 'PhilippeBack 6/24/2012 11:47'!
setBinome: aHOPRBinome
    binome := aHOPRBinome.
	^self ! !

Object subclass: #HOPRExerciseSet
	instanceVariableNames: 'exercises current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRExerciseSet commentStamp: 'PhilippeBack 7/12/2012 17:43' prior: 0!
HOPRExerciseSet represents a set of HOPRExercises!

!HOPRExerciseSet class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 21:46'!
ofType: aSymbol
	| i |
	i := HOPRExerciseSet new.
	i setType: aSymbol.
	^ i! !

!HOPRExerciseSet methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 15:21'!
current
   ^exercises at: current.! !

!HOPRExerciseSet methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 11:46'!
first
  current := 1.
  ^exercises first
! !

!HOPRExerciseSet methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 13:50'!
next
  self flag: #FIXME. "End of set to handle..."
  current := current +1.
  (current > exercises size) ifTrue: [^nil].
  ^exercises at: current.! !

!HOPRExerciseSet methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:50'!
privateGenerateExercise: aSymbol
    
	^(HOPRExercise binome: (HOPRBinome perform: aSymbol))! !

!HOPRExerciseSet methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/24/2012 20:52'!
setType: aSymbol

	| aSelector |
	exercises := OrderedCollection new.
	aSelector := ('make', (aSymbol asString) capitalized) asSymbol.
	20 timesRepeat: [ exercises add: (self privateGenerateExercise: aSelector) ].
	self first.
	^self! !

Object subclass: #HOPRScore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRScore commentStamp: 'PhilippeBack 6/24/2012 14:21' prior: 0!
HOPRScore manages the score!

Object subclass: #HOPRSoundSystem
	instanceVariableNames: 'soundbank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRSoundSystem commentStamp: 'PhilippeBack 7/12/2012 17:40' prior: 0!
HOPRSoundSystem manages the sound for the app.

!

!HOPRSoundSystem methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 22:59'!
initialize
  
  BaseSoundSystem soundEnabled: true.
  BaseSoundSystem initialize.

  soundbank := Dictionary new.
  soundbank add: #rightAnswer -> FMSound flute1.
  soundbank add: #wrongAnswer -> FMSound bassoon1.
  soundbank add: #clearAnswer -> FMSound marimba.

! !

!HOPRSoundSystem methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 23:00'!
play: aSoundSymbol
   (soundbank at: aSoundSymbol) play.! !

Object subclass: #HOPRWindowModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-ProduitsRemarquables'!

!HOPRWindowModel commentStamp: 'PhilippeBack 7/12/2012 17:35' prior: 0!
Apprendre les produits remarquables en s'amusant.

Philippe Back
Catherine Absil
(c)2012 High Octane SPRL!

!HOPRWindowModel methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/12/2012 17:34'!
aboutTitle
  ^'Produits Remarquables'! !

Object subclass: #HOSystemWindowSample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOSystemWindowSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 18:33'!
run
	"Adding morphs to a systemwindow (dual)"

	| win win2 m m2 |
	(win := SystemWindow labelled: 'Astroide') openInWorld.
	win addMorph: HOAstroidMorph new frame: (0 @ 0 extent: 1 @ 1).
	(win2 := SystemWindow labelled: 'Napperons') openInWorld.
	m := HOCanvasMorph new.
	m
		drawBlock: [ :aFormCanvas | 
			| n r t xa xc xb yc ya yb longueur nombreDeDroites aCanvas |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := 200.
			yc := 200.
			n := 15.
			r := 100.
			aCanvas := aFormCanvas asBalloonCanvas.
			aCanvas aaLevel:4.
			aCanvas deferred: true.
			0 to: n - 2 do: [ :i | 
				t := 2 * Float pi * i / n.
				i + 1 to: n - 1 do: [ :j | 
					| tj |
					tj := 2 * Float pi * j / n.
					xa := xc + (r * t cos).
					ya := yc + (r * t sin).
					xb := xc + (r * tj cos).
					yb := yc + (r * tj sin).
					aCanvas asBalloonCanvas line: xa @ ya to: xb @ yb color: Color green ] ].
			aCanvas deferred: false ].
	m2 := HOCanvasMorph new.
	m2
		drawBlock: [ :aFormCanvas | 
			| t xa xc xb yc ya yb longueur nombreDeDroites aCanvas |
			longueur := 150.
			nombreDeDroites := 30.	"super drawOn: aCanvas."
			xc := 200.
			yc := 200.
			ya := yc.
			xb := xc.	"aCanvas line: (self topLeft) to: xc@yc color: Color green."
			aCanvas := aFormCanvas asBalloonCanvas.
			aCanvas aaLevel: 4.
			aCanvas deferred:true.

			0 to: longueur - 1 do: [ :i | 
				t := 2 * Float pi * i / nombreDeDroites.
				xa := xc + (longueur * t cos).
				yb := yc + (longueur * t sin).
				aCanvas line: xa @ ya to: xb @ yb color: Color blue ].
			aCanvas deferred:false. 
			].
	win2 addMorph: m frame: (0 @ 0 extent: 0.5 @ 1).
	win2 addMorph: m2 frame: (0.5 @ 0 extent: 1 @ 1)! !

!HOSystemWindowSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 23:38'!
runTableLayout
	"Adding morphs to a systemwindow (dual)"

	| win m m2 container aColor aMorph |
	(win := SystemWindow labelled: 'Table Layouting Sample') openInWorld.
	win addMorph: (container := Morph new) frame: (0 @ 0 corner: 1 @ 1).
	container
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight.	"Now we can work..."
	
	#(#red #yellow #green)
		do: [ :colorSelector | 
			aColor := Color perform: colorSelector.
			aMorph := Morph new
				color: aColor;
				hResizing: #spaceFill.
			container addMorph: aMorph ].
		win openInWorld.! !

Object subclass: #HOTextFieldSample
	instanceVariableNames: 'changeCount text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTextFieldSample commentStamp: 'PhilippeBack 3/28/2012 12:16' prior: 0!
This class is an example of using a PluggableTextMorph. When a user changes and saves text in the text field, the text and its reverse is displayed in the text field. A count of the number of changes is shown before the text. The original text saved by the user is highlighted. !

!HOTextFieldSample class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:05'!
openInWorld
  ^self new openInWorld.! !

!HOTextFieldSample methodsFor: 'initialization' stamp: 'PhilippeBack 3/28/2012 12:07'!
initialize
	changeCount := 0.
	text := 'Starting'! !

!HOTextFieldSample methodsFor: 'display' stamp: 'PhilippeBack 3/28/2012 12:08'!
openInWorld
	"TextModelExample openInWorld"

	| window display |
	window := SystemWindow labelled: 'Text Example'.
	display := PluggableTextMorph
		on: self
		text: #text
		accept: #text:
		readSelection: #selectTextInterval
		menu: nil.
	window addMorph: display frame: (0 @ 0 extent: 1 @ 1).
	window openInWorld! !

!HOTextFieldSample methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 12:09'!
selectTextInterval
	| headerSize |
	headerSize := changeCount printString size + 1.
	^ Interval from: headerSize + 1 to: text size / 2 + headerSize! !

!HOTextFieldSample methodsFor: 'accessing' stamp: 'PhilippeBack 3/28/2012 12:09'!
text
   ^changeCount printString , ' ' , text! !

!HOTextFieldSample methodsFor: 'accessing' stamp: 'PhilippeBack 3/28/2012 12:17'!
text: aString 
   "Happens on accept"
   changeCount := changeCount + 1.
   text :=  aString , aString reversed.
   self changed: #text.
   ^true! !

Object subclass: #HOToggle
	instanceVariableNames: 'isOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOToggle class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:58'!
new
   ^super new initialize! !

!HOToggle class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:59'!
openInWorld
   "Toggle openInWorld"
   ^self new openInWorld! !

!HOToggle methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:59'!
changeStateLabel
   ^isOn
      ifTrue:['Turn Off']
      ifFalse:['Turn On']! !

!HOToggle methodsFor: 'initialization' stamp: 'PhilippeBack 3/28/2012 11:59'!
initialize
   isOn := true.! !

!HOToggle methodsFor: 'accessing' stamp: 'PhilippeBack 3/28/2012 11:59'!
isOn
   ^isOn! !

!HOToggle methodsFor: 'display' stamp: 'PhilippeBack 3/28/2012 12:00'!
openInWorld
   | window toggleButton |
   window := SystemWindow labelled: 'Toggle Example'.
   window model: self.
   toggleButton := PluggableButtonMorph 
      on: self
      getState: #isOn
      action: #toggle
      label: #changeStateLabel
      menu: nil.
   toggleButton 
      onColor: Color red
      offColor: Color blue.
   toggleButton
      feedbackColor: Color yellow.      
   window 
      addMorph: toggleButton
      frame: (0@0 extent: 1@1).
   window openInWorld.! !

!HOToggle methodsFor: 'effects' stamp: 'PhilippeBack 3/28/2012 12:00'!
toggle
   isOn := isOn not.
   self changed: #changeStateLabel
! !

Object subclass: #HOTools
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOTools class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 18:05'!
formAsString: aForm
"Returns a form as a code representation"
	| stream |
	stream := String new writeStream.
	
	aForm storeOn: stream. 
	
	^stream contents.
	! !

Object subclass: #HOTreeFun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

Object subclass: #HOUsefulSamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Sandbox'!

!HOUsefulSamples commentStamp: 'PhilippeBack 3/18/2012 17:39' prior: 0!
HOUsefulSamples provides samples of using various useful things in Pharo.
Check the class side.!

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/13/2012 10:37'!
dialogWindowsSample
	FreeTypeFontSelectorDialogWindow new openInWorld.
	AboutDialogWindow new openInWorld.
	FileDialogWindow new openInWorld.
	ColorSelectorDialogWindow new openInWorld.
	AlertDialogWindow new openInWorld! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:38'!
dragSample
	|m|
	m := BorderedMorph new.
	m on: #startDrag send: #grabMorph: to: m.
	m on: #click send: #value to:[self inform:'you clicked'].
	m openInWorld
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:36'!
drawingBasicProgramSample
	|lastPt nextPt canvas|
	canvas := Display getCanvas.
    Sensor waitButton.
    lastPt := Sensor cursorPoint.
    [Sensor anyButtonPressed] whileTrue:[
        nextPt := Sensor cursorPoint.
        canvas line: lastPt to: nextPt width: 1 color: Color black.
        lastPt := nextPt.
    ].! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:54'!
formSample2
	| form pen |
	form := Form extent: 150 @ 150 depth: Display depth.
	form fillColor: Color green.
	pen := Pen newOnForm: form.
	pen
		roundNib: 2;
		color: Color red;
		dragon: 9.
	form asMorph openInWorld! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:55'!
formSample3
	| form pen window |
	form := Form extent: 150 @ 150 depth: Display depth.
	form fillColor: Color green.
	pen := Pen newOnForm: form.
	pen
		roundNib: 2;
		color: Color red;
		dragon: 9.
	window := SystemWindow labelled: 'Image'.
	window addMorph: form asMorph frame: (0 @ 0 extent: 1 @ 1).
	window openInWorld! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:37'!
formsSample
|firstForm secondForm |
  firstForm := Form extent: 50@50 depth: Display depth.
  secondForm := Form extent: 50@50 depth: Display depth.
  firstForm fillColor: Color red.
  secondForm fillColor: Color green.
firstForm displayOn: Display at: 100@100.
(Delay forMilliseconds: 1000) wait.
secondForm displayOn: Display at: 100@100.
Display forceDisplayUpdate.
(Delay forMilliseconds: 50) wait.
firstForm displayOn: Display at: 100@100.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 18:43'!
layoutSample1
"How to lay out submorphs

Please read first the well written dynamic essay on Bob's SuperSwiki which you 
find under the name 'MorphLayoutArticle'.

More examples are needed -- add yours here!!

Every Morph now has the capability to layout it's submorphs. Before that only 
the AlignmentMorph could do this, which is now deprecated ( i.e., still in 
place and functioning, but not recommended for use in new code.)

Each Morph can have now its own LayoutPolicy. The new TableLayout corresponds 
to what AlignmentMorph used to do. There is also a ProportionalLayout, which I 
haven't used much. You should also be able to make your own subclasses of 
LayoutPolicy.

Here is some code to lay out some morphs in the new system. You can find other 
layout methods under Morph->layout-properties. Also, play with them from the 
red halo menu of a morph.
"
| m |
m := RectangleMorph new.
m layoutPolicy: TableLayout new.
m listDirection: #leftToRight.
m hResizing: #shrinkWrap; vResizing: #shrinkWrap.
m layoutInset: 20; cellInset: 10.
4 timesRepeat:[ m addMorph: (RectangleMorph new color: (Color red)) ].
m openInWorld.

! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 18:48'!
layoutSample2

| m |
m := RectangleMorph new.
m layoutPolicy: TableLayout new.

m listDirection: #leftToRight. "If you omit this expression you get the default"

"m listDirection: #topToBottom."
m hResizing: #shrinkWrap.
m vResizing: #shrinkWrap.

m addMorph: (EllipseMorph new extent: 40@40; color: Color red).
m addMorph: (EllipseMorph new extent: 50@50; color: Color yellow).
m addMorph: (EllipseMorph new extent: 60@60; color: Color green).
m addMorph: (EllipseMorph new extent: 70@70; color: Color blue).
m openInWorld.

! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 18:48'!
layoutSample3

"Let's start by setting up a background Morph to play with.
(Select this code down to the next comment, and 'DoIt')"

| r e s b |
r := RectangleMorph new.
r color: Color gray.
r position: 10@10.
r extent: 150@200.
r name: 'background'.
r openInWorld.

"OK, now set up our background so that we can put something inside"

r layoutPolicy: TableLayout new. "lay out contents as a table"
r listDirection: #topToBottom. "how we want to place the contents"
r listCentering: #topLeft. "start list at the top"
r wrapCentering: #center. "each item is in the center"
e := EllipseMorph new.
r addMorph: e.

"Now lets add a second item..."

s := RectangleMorph new.
s borderWidth: 1.
s color: Color blue twiceDarker.
r addMorph: s. "note that the new item goes at the top"

"and a third."

b := SimpleButtonMorph new.
b color: Color red;
label: 'remove';
target: r;
actionSelector: #delete;
setBalloonText: 'click to remove the background rectangle and contents'.
r addMorph: b.

"Now let's space things out a bit. Try these one at a time ..."

r cellInset: 2@5. "controls distance between content elements"

r hResizing: #shrinkWrap. "try it and see!!"
r layoutInset: 4@8. "that was a bt too cramped"
r vResizing: #shrinkWrap. "Now we are done"
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:07'!
layoutSample4

| r bullet item1 t1 item2 t2 bbar b block item t sm |
r := RectangleMorph new.
r color: Color blue twiceLighter.
r position: 10@10.
r extent: 150@200.
r name: 'background2'.

"OK, now set up our background so that we can put something inside"

r layoutPolicy: TableLayout new. "lay out contents as a table"
r listDirection: #topToBottom. "how we want to place the contents"
r listCentering: #topLeft. "start list at the top"
r wrapCentering: #topLeft.
r hResizing: #rigid.

sm := StringMorph new.

r addMorphBack: (sm contents:'Change to title'; color: Color white; openInWorld).

"bullet by Ned Konz"
bullet := TextMorph new.
bullet beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
bullet contentsAsIs: (Character value: 165) asString.
bullet color: Color blue.

item1 := Morph new.
item1 layoutPolicy: TableLayout new.
item1 cellPositioning: #topLeft.
item1 cellInset: 4.
item1 color: Color blue twiceLighter twiceLighter.
item1 listDirection: #leftToRight.
item1 addMorph: bullet.
item1 hResizing: #spaceFill.
item1 vResizing: #shrinkWrap.

t1 := TextMorph new.
t1 layoutPolicy: TableLayout new.
t1 hResizing: #spaceFill.
t1 vResizing: #shrinkWrap.
t1 beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
t1 contentsWrapped: 'First list item - aTextMorph'.
t1 autoFit: true.
t1 width: 400.
item1 addMorphBack: t1.
r addMorphBack: item1.
item1 layoutChanged.

"Now lets add a second item..."

item2 := Morph new.
item2 layoutPolicy: TableLayout new.
item2 cellPositioning: #topLeft.
item2 cellInset: 4.
item2 color: Color blue twiceLighter twiceLighter.
item2 listDirection: #leftToRight.
item2 addMorph: bullet duplicate.
item2 hResizing: #spaceFill.
item2 vResizing: #shrinkWrap.

t2 := TextMorph new.
t2 layoutPolicy: TableLayout new.
t2 hResizing: #spaceFill.
t2 vResizing: #shrinkWrap.
t2 beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
"t2 borderWidth: 1."
t2 color: Color blue twiceDarker.
t2 contentsWrapped: 'Second list item - text is editable; click and add
text. The box will grow'.
t2 autoFit: true.
item2 addMorphBack: t2.
r addMorphBack: item2.

"and a button bar ..."

bbar := Morph new.
bbar layoutPolicy: TableLayout new.
bbar cellPositioning: #topLeft.
bbar cellInset: 4.
bbar color: Color blue twiceLighter.
bbar listDirection: #leftToRight.
bbar hResizing: #shrinkWrap.
bbar vResizing: #shrinkWrap.

b := SimpleButtonMorph new.
b color: Color yellow;
label: 'remove button bar';
target: bbar;
actionSelector: #delete;
setBalloonText: 'click to remove the button bar'.
bbar addMorph: b.
r addMorph: bbar.

block := [ :r2 |
item := Morph new.
item layoutPolicy: TableLayout new.
item cellPositioning: #topLeft.
item cellInset: 4.
item color: Color blue twiceLighter twiceLighter.
item listDirection: #leftToRight.
item addMorph: bullet duplicate.
item hResizing: #spaceFill.
item vResizing: #shrinkWrap.

t := TextMorph new.
t layoutPolicy: TableLayout new.
t hResizing: #spaceFill.
t vResizing: #shrinkWrap.
t beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1).
t contentsWrapped: 'A list item - aTextMorph'.
t autoFit: true.
t width: 400.
item addMorphBack: t.
r2 addMorphBack: item.
].

b := SimpleButtonMorph new.
b color: Color yellow;
label: 'add other item';
setBalloonText: 'click to add another bullet list item'.
bbar addMorph: b.
b target: block.
b actionSelector: #value:.
b arguments: (Array with: b owner owner).
r addMorph: bbar.

b := SimpleButtonMorph new.
b color: Color yellow;
label: 'X';
setBalloonText: 'click to delete bullet list completely'.
bbar addMorph: b.
b target: r.
b actionSelector: #delete.
r addMorph: bbar.

r cellInset: 3@5. "controls distance between content elements"

r openInWorld.
r hResizing: #shrinkWrap. "try it and see!!"
r layoutInset: 4@8. "that was a bit too cramped"
r vResizing: #shrinkWrap. "Now we are done"
item1 layoutChanged.
item2 layoutChanged.

! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:11'!
layoutSample5

Morph new
color: Color green;
extent: 300 @ 300;
layoutPolicy: ProportionalLayout new;
addMorph: (
Morph new color: (Color blue alpha: 0.5)
)
fullFrame: (
LayoutFrame fractions: (0@1 corner: 1 @ 1) offsets: (0@100 negated corner: 0@0)
);

addMorph: (
Morph new
color: (Color red alpha: 0.5);
layoutPolicy: ProportionalLayout new;
addMorph: (
Morph new
color: (Color yellow alpha: 0.5);
layoutPolicy: TableLayout new;
listDirection: #topToBottom;
listCentering: #center;
addMorph: (
Morph new extent: 100@2; color: Color black; hResizing: #spaceFill
)
)
fullFrame: (LayoutFrame fractions: (0@0 corner: 0.9 @ 0.9) offsets: nil)
)
fullFrame: (
LayoutFrame fractions: (0@0 corner: 1 @ 1) offsets: (0@0 corner: 0@100 negated)
);
openInWorld.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:13'!
layoutSample6
| rectangle string frame |
"set up the string"
string := StringMorph new contents: 'This is a string'.

"this is the trick - set up a layout frame so that
it will align the string at the top-center of the owner
but offset left by half of the string's width"
frame := LayoutFrame new.
frame leftFraction: 0.5 offset: string width // -2.
frame topFraction: 0 offset: 0.

"install it"
string layoutFrame: frame.

"the container"
rectangle := RectangleMorph new.
rectangle layoutPolicy: ProportionalLayout new.
rectangle addMorph: string.

"clip parent so string doesn't show outside"
rectangle clipSubmorphs: true.
rectangle openInHand.
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 19:14'!
layoutSample7
| rectangle string |
"the container"
rectangle := RectangleMorph new.

"this is the trick - set up a layout
so that it is oriented left to right and
then center the entire list"
rectangle layoutPolicy: TableLayout new.
rectangle listDirection: #leftToRight.
rectangle listCentering: #center.

"Note: the same effect could be achieved using:
rectangle listDirection: #topToBottom.
rectangle wrapCentering: #center.
This may work better if the entire contents
of the rectangle should be a vertical list"

"set up the string"
string := StringMorph new contents: 'This is a string'.
rectangle addMorph: string.

"clip parent so string doesn't show outside"
rectangle clipSubmorphs: true.
rectangle openInHand.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/14/2012 12:26'!
loadIconTool
"Load Spec if needed"
Gofer new
        url: 'http://ss3.gemstone.com/ss/Spec';
        package: 'ConfigurationOfSpec';
        load.

(ConfigurationOfSpec project version: #stable) load.
Gofer it
        squeaksource3: 'SpdPlayground';
        package: 'IconBrowser';
        load.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:37'!
morphicModifierSample
	^ActiveHand shiftPressed.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 20:15'!
selectRectangleFromUserSample
^Rectangle fromUser.
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/13/2012 10:34'!
showFontDialog

	FreeTypeFontSelectorDialogWindow new openInWorld.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 23:19'!
simpleLoggerSample
	"SimpleLogger

SimpleLogger developed by Germn Arduino is available at http://ss3.gemstone.com/ss/SimpleLogger.html. SimpleLogger is a really simple text only logger.

It's simple to install, only point your Monticello Browser to:
"

	| aLogger |

"	MCHttpRepository location: 'http://ss3.gemstone.com/ss/SimpleLogger' user: '' password: "''.	"and load the latest version.

Use it is also simple:
"
	aLogger := G9Logger new.	"

Creates a new instance of SimpleLogger, opening a text file named for example: 15 July 2010 6#15#01 am.txt

Then, to log things on such file you can use the following messages:
"
	aLogger log: 'Text to log on the logfile'.	"Will log the phrase 'Text to log on the logfile on the logfile."
	aLogger logSeparator.	"Will log a line of '-' to separate sections on the logfile."
	aLogger logWithTimeStamp: 'This text was written at: '.	"Will log a the phrase 'This text was written at: 15 July 2010 6:24:03 am' in the logfile."
	aLogger closeLogFile	"Will close the log file, writing some closing text.
The complete session of the previous samples will generate this log file:

----------------------------------------------------------------
G9Logger started at:  15 July 2010 6:15:01 am
----------------------------------------------------------------
Text to log on the logfile
----------------------------------------------------------------
This text was written at:  15 July 2010 6:24:03 am
----------------------------------------------------------------
G9Logger ended at: 15 July 2010 6:27:09 am
----------------------------------------------------------------
-------G9Logger is a product from Arduino Software--------------
---Web: http://www.arduinosoftware.com---Mail: info@arsol.net---
"! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 14:06'!
soundPianoRollSample
	"And now for some Morphs with sound..."

	| pm |
	pm := PianoKeyboardMorph new.
	pm soundPrototype: FMSound randomWeird2.
	pm openInWorld! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 14:05'!
soundSamples
	"Test hardware"

	| ss |
	SoundPlayer boinkScale.	"See if sound is enabled"
	SoundService soundEnabled.	"This should answer the BaseSoundSystem class"
	SoundService registeredClasses.
	SoundService reset.
	BaseSoundSystem soundEnabled: true.
	SoundService default.	"Let's make some noise"
	ss := SoundService default new.
	ss class soundEnabled.
	ss class soundEnabled: true.
	ss beep.
	(FMSound lowMajorScaleOn: FMSound pluckedElecBass) play.
	(FMSound lowMajorScaleOn: FMSound randomWeird1) play.
	(FMSound majorScaleOn: FMSound oboe1) play.
	FMSound testFMInteractively.
	(SampledSound bachFugueVoice2On: SampledSound new) play.
	SoundPlayer shutDown! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 17:53'!
streamStringSample1
	| stream |
	stream := String new writeStream.
	stream
		nextPutAll: 'Cette image Smalltalk contient: ';
		print: Smalltalk allClasses size;
		nextPutAll: ' classes.';
		cr;
		nextPutAll: 'C''est vraiment beaucoup'.
	stream contents explore.! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 6/23/2012 17:57'!
streamStringSample2
	| stream form |
	stream := String new writeStream.
	
	form := Form extent: (100@100) depth: 32.
	form storeOn: stream. 
	
	"stream
		nextPutAll: 'Cette image Smalltalk contient: ';
		print: Smalltalk allClasses size;
		nextPutAll: ' classes.';
		cr;
		nextPutAll: 'C''est vraiment beaucoup'.
	"
	stream contents explore.
	! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/15/2012 01:07'!
stringMorphFontSample1
| sm ts font font2 |
sm := StringMorph new.
sm contents: 'Hello'.
sm openInWorld.
ts := TextStyle default copy.
font := ts fontIndexOf: 3.
font := ts fontAt: 3.

"font := StrikeFont fromUser.
"

font2 := StrikeFont familyName: (StrikeFont dejaVuKey) pointSize: 24.

sm font: font2.
sm changed.
sm color: Color green.
! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 17:34'!
timingSample
|list count thisTick nextTick|

list := Array new: 1000.
count := 0.
thisTick := Time millisecondClockValue.
[count < 1000] whileTrue:[
    nextTick := Time millisecondClockValue.
    nextTick = thisTick ifFalse:[
        count := count + 1.
        list at: count put: (nextTick - thisTick).
        thisTick := nextTick.
    ].
].! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 21:34'!
trueTypeExample
	"Using TrueType"

	| smf |
	smf := TTSampleStringMorph new.
	smf loadFromURL: 'http://ireader.googlecode.com/files/arial.ttf'.
	smf string: 'Hello'.
	smf openInHand.
	smf color: Color green.
	smf string: 'True Type in Pharo'.
	smf edit.	"smf addCustomMenuItems: ? hand: ActiveHand. "
	smf printOn: Transcript.
	smf position: 10 @ 50! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/29/2012 22:55'!
trueTypeExample2
	"We need to use a TTFontReader for loading from a Stream.f"
	"Make sure to check the TTSampleStringMorph>>addCustomMenuItems:... and the Morph menu
	when it is created."

	| tfd ttm |
	tfd := TTFontDescription addFromTTFile: '/Users/philippeback/Angles Octagon.ttf'.
	ttm := TTSampleFontMorph font: tfd.
	ttm color: Color blue.
	ttm:=TTSampleStringMorph font: tfd.
	ttm string: 'SpiderMan'.
	ttm bounds: (0@0 extent: 500@300). "Scale!!"
	ttm color: Color red.
	ttm borderColor: Color blue.
	ttm borderWidth: 2.
	ttm openInHand! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/18/2012 20:19'!
usageOfPenSample1
| myPen |
Display restoreAfter: [
   Display fillWhite.

myPen := Pen new.                                           "get graphic pen"
myPen squareNib: 1.
myPen color: (Color red).                                  "set pen color"
myPen home.                                                 "position pen at center of display"
myPen up.                                                   "makes nib unable to draw"
myPen down.                                                 "enable the nib to draw"
myPen north.                                                "points direction towards top"
myPen turn: -180.                                           "add specified degrees to direction"
myPen direction.                                            "get current angle of pen"
myPen go: 50.                                               "move pen specified number of pixels"
myPen location.                                             "get the pen position"
myPen goto: 200@200.                                        "move to specified point"
myPen place: 250@250.                                       "move to specified point without drawing"
myPen print: 'Hello World' withFont: (TextStyle default fontAt: 1).
Display extent.                                             "get display width@height"
Display width.                                              "get display width"
Display height.                                             "get display height"

].! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 3/28/2012 11:51'!
usageOfPenSample2
	| pen |
	Display
		restoreAfter: [ 
			Display fillWhite.
			pen := Pen newOnForm: Display.
			pen defaultNib: 2.
			pen
				fill: [ :each | 
					6
						timesRepeat: [ 
							each
								go: 100;
								turn: 60 ] ]
				color: Color red ]! !

!HOUsefulSamples class methodsFor: 'as yet unclassified' stamp: 'PhilippeBack 7/12/2012 18:43'!
usageOfPenSample3
   "This is completely wrong in Pharo..."
	| pen |
	Display
		restoreAfter: [ 
			Display fillWhite.
			pen := Pen new.
			pen
				squareNib: 1.";
				color: Color red;
				turn: 0."
			
			pen
				print:
					'The owl and the pussycat went to sea
in a beautiful pea green boat.'
				withFont: TextStyle defaultFont ]! !

Object subclass: #Project
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HighOctane-Compatibility'!
